unit WeekCal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, uStrings, stdctrls;

type
  TOverApptEvent = procedure(Sender: TObject; var x, y:integer; sMisc:string) of object;
  TApptTimes = class(tobject)
       aStart : string;
       aEnd : string;
       aDesc : string;
       aUser : string;
       yTop : integer;
       yBot : integer;
       sMisc : string;
  end;
  TUserColor = class(tobject)
     color : TColor;
  end;
  TWeekCal = class(TPaintBox)
  private
    { Private declarations }
    FOffAppt : TNotifyEvent;
    FOverAppt : TOverApptEvent;
    FOnPaint: TNotifyEvent;
    FTimes : TStringlist;
    FDayStart : string;
    FDayEnd : string;
    FApptColor : TColor;
    FUsers : TstringList;
    FShowAll : boolean;
    FShowUser : string;
    FBitMap : TBitmap;
    frWid : integer;
    colWid : integer;
    frht : integer;
    fWeekDate : TDateTime;
    fDayDate : TDateTime;
    sHint : string;
    fEnding : boolean;
    bOverAppt : boolean;
    procedure WMMouseMove(var Message: TWMMouseMove); message WM_MOUSEMOVE;
  protected
    { Protected declarations }
    procedure Paint; override;
    procedure SetTimes(Value: TStringlist);
    procedure SetWeekDate(wkDate : TDateTime);
    Function GetValueCount(sDelimitedString, sDelimiter : String) : Integer;
    Function GetValue(sDelimitedString, sDelimiter : String;
                  iOccurence : Integer) : String;
    procedure SetApptColor(Value: TColor);
    procedure SetShowAll(value : Boolean);
    procedure SetUser(value : string);
    procedure DrawTimes(iMin,iLeft,iRight:integer;theCanvas:tcanvas);
    procedure DoOverAppt(x, y:integer; sMisc : string); dynamic;
    procedure DoOffAppt; dynamic;
    function  Apptidx(x,y,iDay:integer):integer;
    function ConvTime(sTime:string):string;
  public
    { Public declarations }

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

  published
    { Published declarations }
    property Align;
    property Anchors;
    property Color;
    property Constraints;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Visible;
    property ApptColor: TColor read FApptColor write SetApptColor stored true default clAqua;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property ShowAllUsers : boolean read FShowAll write SetShowAll default true;
    property ShowUser : string read FShowUser write SetUser;
    property OnPaint: TNotifyEvent read FOnPaint write FOnPaint;
    property OnOverAppt: TOverApptEvent read FOverAppt write FOverAppt;
    property OnOffAppt: TNotifyEvent read FOffAppt write FOffAppt;
    property OnStartDock;
    property OnStartDrag;
    property Times : tstringlist read FTimes write SetTimes;
    Property DayStart : string read FDayStart write FDayStart;
    property DayEnd : string read FDayEnd write FDayEnd;
    property WeekDate : TDateTime read FWeekDate write SetWeekDate;
    property DayDate : TDateTime read FDayDate;
    procedure SetTime(iDay : integer; tStart, tEnd, Desc, sUser, sMisc : string);
    Procedure ClearTimes;
    procedure SetUserColor(sUser : string; cColor : Tcolor);
    function MousetoDateTime(x,y:integer):TDateTime;


    //function  ISApptRect(mPos:TPoint;var Desc:string):boolean;
  end;

var
    tDays : array[0..6] of tDateTime;
    sdays : array[0..6] of string = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
    aTimes : array[0..23] of string = ('00:00','01:00','02:00','03:00','04:00','05:00','06:00',
                             '07:00','08:00','09:00','10:00','11:00','12:00','13:00',
                             '14:00','15:00','16:00','17:00','18:00','19:00','20:00',
                             '21:00','22:00','23:00');
{    aTimes : array[0..23] of string = ('00:00','01:00','02:00','03:00','04:00','05:00','06:00',
                             '07:00','08:00','09:00','10:00','11:00','12:00','01:00',
                             '2:00','3:00','4:00','5:00','6:00','7:00','8:00',
                             '9:00','10:00','11:00');
}

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('WeekCal', [TWEEKCAL]);
end;

constructor TWeekCal.Create(AOwner: TComponent);
var
   frWid : integer;
   frht : integer;
   i : integer;
begin
  inherited Create(AOwner);
  fEnding := false;
  fTimes := TStringList.Create;
  fUsers := TStringList.Create;
  FBitMap := TBitmap.Create;
  FDayStart := '8:00';
  FDayEnd := '17:00';
  FApptColor := clAqua;
  FShowAll := true;
  bOverAppt := false;
  FWeekDate := now;
end;

procedure TWeekCal.DoOffAppt;
begin
   if assigned(FOffAppt) then begin
       FOffAppt(self);
   end;
end;

procedure TWeekCal.SetWeekDate(wkDate : TDateTime);
begin
   FWeekDate := wkDate;
end;

function TWeekCal.ConvTime(sTime:string):string;
var
   iTime : integer;
begin
   iTime := strtoint(getvalue(sTime,':',1));
   if iTime > 12 then begin
       iTime := iTime - 12;
   end;
   Result := inttostr(iTime)+':'+getValue(sTime,':',2);
end;

procedure TWeekCal.DoOverAppt(x, y:integer; sMisc : string);
begin
   if Assigned(FOverAppt) then begin
       FOverAppt(self,x,y,sMisc);
   end;
end;

function  TWeekCal.Apptidx(x,y,iDay:integer):integer;
var
   i, iIndex : integer;
begin
   Result := -1;
   iIndex := FTimes.IndexOf(inttostr(iDay));
   for i := iIndex to FTimes.Count - 1 do begin
       if FTimes[i] = inttostr(iDay) then begin
           if (y >= TApptTimes(fTimes.Objects[i]).yTop) and
              (y <= TApptTimes(fTimes.Objects[i]).yBot) then begin
              Result := i;
           end;
       end;//if FTimes[i]
   end;//for i := iIndex (loop through the set)
end;//ApptIDX

function TWeekCal.MousetoDateTime(x,y:integer):TDateTime;
var
   minsinday:integer;
   mas : integer;
   hr, mt : integer;
   hs,he : word;
   mins, mine : word;
   secs, sece : word;
   sss, sse : word;
   timeout : real;

begin
   //MousetoDateTime
   decodetime(strtodatetime(fDayend),he,mine,sece,sse);
   decodetime(strtodatetime(fDaystart),hs,mins,secs,sss);
   minsinday := trunc((frac(strtodatetime(fDayEnd))*1440)-(frac(strtodatetime(fDayStart))*1440));
   mas := trunc(minsinday * ((y-16)/height));
   hr := hs + trunc(mas/60);
   mt := mas mod 60;
   if mt < 15 then begin
       mt := 0;
   end else if mt <= 20 then begin
       mt := 15;
   end else if mt <= 40 then begin
       mt := 30;
   end else if mt <= 50 then begin
       mt := 45;
   end else if mt > 50 then begin
       mt := 0;
       inc(hr);
   end;
   timeout := trunc(fDayDate)+ frac((strtodatetime(inttostr(hr)+':'+inttostr(mt))));
   result := timeout;

end;//MousetoDateTime

procedure TWeekCal.WMMouseMove(var Message: TWMMouseMove);
var
   x, y : integer;
   mp : TPoint;
   cp : tPoint;
   frWid : integer;
   iDay : integer;
   iIndex : integer;
   iAppt : integer;
begin
  inherited;
   frWid := trunc(width/7);
   x := Message.XPos;
   y := Message.YPos;
   mp.x := x;
   mp.y := y;
   cp := Screentoclient(mp);
   if (x<frWid) then begin
       //hint := 'Sunday';
       iDay := 0;
   end else begin
       if (x < frWid * 2) then begin
           //hint := 'Monday';
           iDay := 1;
       end else begin
           if (x < frWid * 3) then begin
              // hint := 'Tuesday';
               iDay := 2;
           end else begin
               if (x < frWid * 4) then begin
                //   hint := 'Wednesday';
                   iDay := 3;
               end else begin
                   if (x < frWid * 5) then begin
                  //     hint := 'Thursday';
                       iDay := 4;
                   end else begin
                       if (x < frWid * 6) then begin
                    //       hint := 'Friday';
                           iDay := 5;
                       end else begin
                      //     hint := 'Saturday';
                           iDay := 6;
                       end;
                   end;
               end;
           end;
       end;
   end;
   iIndex := ftimes.IndexOf(inttostr(iDay));
   if  iIndex > - 1 then begin
       Hint := 'Appointments Today!';
       iAppt := ApptIDX(x,y,iDay);
       if iAppt > -1 then begin
           if not bOverAppt then begin
              bOverAppt := true;
              DoOverappt(frWid * iDay,TApptTimes(fTimes.Objects[iAppt]).yTop,TApptTimes(fTimes.Objects[iAppt]).sMisc);
           end;
       end else begin
           if bOverAppt then begin
               bOverAppt := false;
               DoOffAppt;
           end;
       end;
   end else begin
       if bOverAppt then begin
          bOverAppt := false;
          DoOffAppt;
       end;
       Hint := 'Open All Day!';

   end;
   if tDays[iday] <> fDayDate then begin
      fDayDate := tDays[iDay];
   end;

end;


destructor TWeekCal.Destroy;
var
   i : integer;
begin
  fEnding := true;
  ClearTimes;
  FTimes.Free;
  for i := 0 to fUsers.Count - 1 do begin
      TUserColor(fUsers.objects[i]).free;
  end;
  FUsers.free;
  FBitMap.Free;
  inherited Destroy;
end;



procedure TWeekCal.SetApptColor(Value: TColor);
begin
  if FApptColor <> Value then
  begin
    FApptColor := Value;
    Perform(CM_COLORCHANGED, 0, 0);
  end;
end;

function  ISApptRect(mPos:TPoint;var Desc:string):boolean;
begin

end;

procedure tWeekCal.SetUserColor(sUser : string; cColor : Tcolor);
var
   myColor : TUserColor;
begin
   //Set user color
   myColor := TUserColor.Create;
   myColor.color := cColor;
   FUsers.AddObject(sUser,myColor);
end;

procedure tWeekCal.SetShowAll(value : Boolean);
begin
   FShowAll := value;
   paint;
end;

procedure tWeekCal.SetUser(value : string);
begin
   FShowUser := value;
   paint;
end;

procedure tWeekCal.DrawTimes(iMin,iLeft,iRight:integer;theCanvas:tcanvas);
var
   i : integer;
   iDayStart : integer;
   iDayEnd : integer;
   rTimeCal : real;
   rTimeSlot : real;
   rDayStart : real;

begin
   iDayStart := strtoint(copy(FDayStart,1,1));
   iDayEnd := strtoint(copy(FDayEnd,1,2));
   rDayStart := frac(strtodatetime(FDayStart));
   for i := iDayStart to iDayEnd do begin
       rTimeSlot := frac(strtodatetime(aTimes[i]));
       rTimeCal := ((rTimeSlot*1440)-(rDayStart*1440))/iMin;
       thecanvas.TextOut(iLeft+3,trunc(height*rTimeCal)+15,convTime(aTimes[i]));
   end;//for i := iDayStart to iDayEnd
end;//DrawTimes;


procedure tWeekCal.Paint;
var
   frWid : integer;
   frht : integer;
   i : integer;
   iDay : integer;
   rStart : real;
   rEnd : real;
   rDayStart : real;
   rDayEnd : real;
   svColor : TColor;
   iDayMinutes : integer;
   svFont : TFont;
   sUser : string;
   iUserIndex : integer;
   TheCanvas : TCanvas;
   TimeRec :TApptTimes;
   oldbkmode : integer;
   sDayDate : string;
   iDow : integer;

begin
  Canvas.Font := Font;
  Canvas.Brush.Color := Color;

  fBitmap.Width := width;
  fBitMap.Height := height;
  fBitMap.Canvas.Font := canvas.Font;
  fBitMap.Canvas.Brush := Canvas.Brush;
  fBitMap.Canvas.Pen := canvas.Pen;
  TheCanvas := FBitMap.Canvas;


    frWid := trunc(Width / 7);
    if frWid <> colWid then begin
       colWid := frWid;
    end;
    frht := Height;
    rDayStart := frac(strtodatetime(FDayStart));
    rDayEnd := frac(strtodatetime(FDayEnd));


    iDayMinutes := trunc((1440*rDayEnd)-(1440*rDayStart));
    for i := 0 to 6 do begin
       with Thecanvas do begin
            if i <> 6 then begin
               rectangle(rect(i*frWid,0,(i*frWid)+frWid,frht));
            end else begin
               rectangle(rect(i*frWid,0,(i*frWid)+(width-(i*frwid)),frht));
            end;

            iDow := dayofweek(fWeekDate)-1;
            if iDow <> i then begin
               sDayDate := Datetostr(FWeekDate + (i- iDow));
            end else begin
               sDayDate := Datetostr(FWeekDate);
            end;
            TDays[i] := strtoDate(sDayDate);
            textout((i*frwid)+2,2,sDays[i]+'   '+sDayDate);
            DrawTimes(iDayMinutes,i*frWid,(i*frWid)+frWid,TheCanvas);
       end;
    end;
    TheCanvas.MoveTo(0,14);
    TheCanvas.LineTo(width,14);
    for i := 0 to FTimes.Count - 1 do begin
        //canvas.TextOut((i*frwid)+2,2,'Hello');
           TimeRec := TApptTimes(fTimes.Objects[i]);
           sUser := TimeRec.aUser;
           if (FShowAll) or ((not FshowAll) and (sUser = FShowUser)) then begin
               iUserIndex := FUsers.IndexOf(sUser);
               iDay := strtoint(fTimes[i]);
               rStart := frac(strtodatetime(timeRec.aStart));
               rEnd := frac(strtodatetime(TimeRec.aEnd));
               //canvas.TextOut((i*frwid)+2,40,floattostr(rDayStart));
               //canvas.TextOut((i*frwid)+2,50,floattostr(rDayEnd));
               rStart := ((rStart*1440)-(rDayStart*1440))/iDayMinutes;
               rEnd := ((rEnd*1440)-(rDayStart*1440))/iDayMinutes;
               // canvas.TextOut((i*frwid)+2,32,inttostr(iDayMinutes));
               // canvas.TextOut((i*frwid)+2,2,floattostr(rStart));
               // canvas.TextOut((i*frwid)+2,20,floattostr(rEnd));
               if rStart < rEnd then begin

                   svColor := Thecanvas.Brush.Color;
                   svFont := TheCanvas.Font;
                   TheCanvas.Font.Size := 7;

                   if iUserIndex > -1 then begin
                       Thecanvas.Brush.Color := TUserColor(FUsers.Objects[iUserIndex]).color;
                   end else begin
                       Thecanvas.Brush.Color := FApptColor;
                   end;
                   //oldbkMode := SetbkMode(thecanvas.handle,TRANSPARENT);
                   //canvas.rectangle(rect(iDay*frWid+5,trunc(height*rStart),(iDay*frWid)+(frWid-5),trunc(height*rEnd)));
                   Thecanvas.TextRect(rect(iDay*frWid+5,trunc(height*rStart)+15,(iDay*frWid)+(frWid-5),trunc(height*rEnd)+15),
                                   iDay*frWid+6,trunc(height*rStart)+16,ConvTime(TimeRec.aStart)+'-'+ConvTime(TimeRec.aEnd));
                   TimeRec.yTop := trunc(height*rStart)+15;
                   TimeRec.yBot := trunc(height*rEnd)+15;
                   Thecanvas.TextRect(rect(iDay*frWid+5,trunc(height*rStart)+26,(iDay*frWid)+(frWid-5),trunc(height*rEnd)+15),
                                   iDay*frWid+6,trunc(height*rStart)+26,TimeRec.aDesc);
                   TheCanvas.Brush.Color := clBlack;
                   TheCanvas.Rectangle((iDay*frWid)+(frWid-5),trunc(height*rStart)+17,(iDay*frWid)+(frWid-3),trunc(height*rEnd)+17);
                   TheCanvas.Rectangle((iDay*frWid)+7,trunc(height*rEnd)+15,(iDay*frWid)+(frWid-5),trunc(height*rEnd)+17);
                   Thecanvas.Brush.Color := svColor;
                   TheCanvas.Font := svFont;
                   //SetbkMode(TheCanvas.Handle,oldbkMode);
               end;//if rStart < rEnd
           end;//if showuser, blah blah blah

    end; //for all times
    BitBlt(self.Canvas.Handle,0,0,Width,height,TheCanvas.handle,0,0,srccopy);
  TimeRec := nil;
  if Assigned(FOnPaint) then FOnPaint(Self);
end;

procedure TWeekCal.SetTimes(Value: TStringlist);
begin
  FTimes.Assign(Value);
end;

procedure TWeekCal.SetTime(iDay : integer; tStart, tEnd, Desc, sUser, sMisc : string);
var
   aRec : TApptTimes;
begin
   if (iDay > -1) and (iDay < 7) then begin
      aRec := TApptTimes.Create;
      aRec.aStart := tStart;
      aRec.aEnd := tEnd;
      aRec.aDesc := desc;
      aRec.aUser := suser;
      aRec.sMisc := sMisc;
      fTimes.AddObject(inttostr(iDay),aRec);
      //fTimes.Add(inttostr(iDay)+','+tStart+','+tEnd+','+Desc+','+sUser);
      Paint;
   end;
end;

procedure TWeekCal.ClearTimes;
var
   i : integer;
begin
   for i := 0 to fTimes.Count - 1 do begin
       TApptTimes(fTimes.Objects[i]).free;
   end;
   fTimes.Clear;
   if not FEnding then begin
       Paint;
   end;
end;

FUNCTION TWeekCal.GetValueCount(sDelimitedString, sDelimiter : String) : Integer ;
var
   iLocationInString : Integer;
   iOccurencesFound : Integer;

BEGIN
   iOccurencesFound := 0;
  // GetValueCount := 1;


   //check if the delimiter is in the string
   iLocationInString := Pos(sDelimiter, sDelimitedString);
   IF ( iLocationInString > 0 ) THEN BEGIN
      //count each occurence of the delimiter in the string
      //!!!!!!!!iOccurencesFound := 1;

      //Loop around the string to find another thing
      Repeat
         iLocationInString := Pos(sDelimiter, sDelimitedString);
         IF ( iLocationInString > 0 ) THEN BEGIN
            iOccurencesFound := iOccurencesFound + 1;
            sDelimitedString := GetRight(sDelimitedString, Length(sDelimitedString)-iLocationInString);
//            iLocationInString := 0;
         END;

      until iLocationInString <= 0;

      inc(iOccurencesFound);
      GetValueCount := iOccurencesFound;

   END
   ELSE BEGIN

      //the delimiter is not found in the string
      //the string is empty OR there is 1 value
      IF ( Length(sDelimitedString) > 0 ) THEN BEGIN
         GetValueCount := 1;
      END
      ELSE BEGIN
         GetValueCount := 0;
      END; //IF Len(str) > 0

   END; {IF iLocationInString > 0}

END; {GetValueCount}



FUNCTION TWeekCal.GetValue(sDelimitedString, sDelimiter : String;
                  iOccurence : Integer)  : String;

var
  iValueCount : integer;
  iFoundAtLoc : integer;
  sRemainingString : string;
  i : integer;
  iForLoopOccurence: integer;

BEGIN
  //if the delimiter is in the string
  iValueCount := GetValueCount(sDelimitedString, sDelimiter);

  //if there are any values & the requested occ is in the string
  if (iValueCount > 0) and (iOccurence <= iValueCount) and (iOccurence > 0) then begin
     //get the requested value
      sRemainingString := sDelimitedString;
      iForLoopOccurence := iOccurence - 1;

     for i := 1 to iForLoopOccurence do begin
       iFoundAtLoc := Pos(sDelimiter, sRemainingString);
//       sRemainingString := GetRight(sRemainingString,
//                           Length(sRemainingString) - iFoundAtLoc);
       sRemainingString := GetRight(sRemainingString,
                           Length(sRemainingString) -
                           (iFoundAtLoc + (Length(sDelimiter) - 1)));
     end; //for 1 = 1 to iOccurence

     //the next value is the one
     iFoundAtLoc := Pos(sDelimiter, sRemainingString);
     if iFoundAtLoc = 0 then
       GetValue := sRemainingString
     else
       GetValue := GetLeft(sRemainingString, iFoundAtLoc-1);

  end //if requested value is valid

  else
     GetValue := '';

END; //GetValue


end.
